﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;

namespace AdventOfCode2023
{
    public abstract class DayBase
    {
        public enum Encodings
        {
            Default,
            UTF8,
            ASCII
        }

        public static string GetInput(string fileName, Encodings encoding = Encodings.Default)
        {
            Encoding enc;

            switch (encoding)
            {
                case Encodings.Default:
                    enc = Encoding.Default;
                    break;
                case Encodings.UTF8:
                    enc = Encoding.UTF8;
                    break;
                case Encodings.ASCII:
                    enc = Encoding.ASCII;
                    break;
                default:
                    enc = Encoding.Default;
                    break;
            }

            var assembly = Assembly.GetExecutingAssembly();
            var resourceName = $"AdventOfCode2023.Inputs.{fileName}";

            string result = string.Empty;

            using (Stream stream = assembly.GetManifestResourceStream(resourceName) ?? throw new FileNotFoundException($"Could not find resource: {resourceName}!"))
            using (StreamReader reader = new StreamReader(stream, enc))
            {
                result = reader.ReadToEnd();
            }

            return result;
        }

        public abstract string Execute();
    }
}
